AbstractExcelView (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.web.servlet.view.document

## Class AbstractExcelView

- java.lang.Object
- - org.springframework.context.support.ApplicationObjectSupport
  - - org.springframework.web.context.support.WebApplicationObjectSupport
    - - org.springframework.web.servlet.view.AbstractView
      - - org.springframework.web.servlet.view.document.AbstractExcelView

- All Implemented Interfaces:
    Aware, BeanNameAware, ApplicationContextAware, ServletContextAware, View

      public abstract class AbstractExcelView
      extends AbstractView

  Convenient superclass for Excel document views. Compatible with Apache POI 3.0 as well as 3.5, as of Spring 3.0.

  Properties:

  - url (optional): The url of an existing Excel document to pick as a starting point. It is done without localization part nor the ".xls" extension.

  The file will be searched with locations in the following order:

  - [url]_[language]_[country].xls
  - [url]_[language].xls
  - [url].xls

  For working with the workbook in the subclass, see Jakarta's POI site

  As an example, you can try this snippet:

       protected void buildExcelDocument(
           Map<String, Object> model, HSSFWorkbook workbook,
           HttpServletRequest request, HttpServletResponse response) {

         // Go to the first sheet.
         // getSheetAt: only if workbook is created from an existing document
               // HSSFSheet sheet = workbook.getSheetAt(0);
               HSSFSheet sheet = workbook.createSheet("Spring");
               sheet.setDefaultColumnWidth(12);

         // Write a text at A1.
         HSSFCell cell = getCell(sheet, 0, 0);
         setText(cell, "Spring POI test");

         // Write the current date at A2.
         HSSFCellStyle dateStyle = workbook.createCellStyle();
         dateStyle.setDataFormat(HSSFDataFormat.getBuiltinFormat("m/d/yy"));
         cell = getCell(sheet, 1, 0);
         cell.setCellValue(new Date());
         cell.setCellStyle(dateStyle);

         // Write a number at A3
         getCell(sheet, 2, 0).setCellValue(458);

         // Write a range of numbers.
         HSSFRow sheetRow = sheet.createRow(3);
         for (short i = 0; i < 10; i++) {
           sheetRow.createCell(i).setCellValue(i * 10);
         }
       }

  This class is similar to the AbstractPdfView class in usage style.
  Author:
    Jean-Pierre Pawlak, Juergen Hoeller
  See Also:
    `AbstractPdfView`

- - ### Field Summary

    - ### Fields inherited from class org.springframework.web.servlet.view.AbstractView

      `DEFAULT_CONTENT_TYPE`

    - ### Fields inherited from class org.springframework.context.support.ApplicationObjectSupport

      `logger`

    - ### Fields inherited from interface org.springframework.web.servlet.View

      `PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE, SELECTED_CONTENT_TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractExcelView()` Default Constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract void` | `buildExcelDocument(Map<String,Object> model, org.apache.poi.hssf.usermodel.HSSFWorkbook workbook, HttpServletRequest request, HttpServletResponse response)` Subclasses must implement this method to create an Excel HSSFWorkbook document, given the model.
    `protected boolean` | `generatesDownloadContent()` Return whether this view generates download content (typically binary content like PDF or Excel files).
    `protected org.apache.poi.hssf.usermodel.HSSFCell` | `getCell(org.apache.poi.hssf.usermodel.HSSFSheet sheet, int row, int col)` Convenient method to obtain the cell in the given sheet, row and column.
    `protected org.apache.poi.hssf.usermodel.HSSFWorkbook` | `getTemplateSource(String url, HttpServletRequest request)` Creates the workbook from an existing XLS document.
    `protected void` | `renderMergedOutputModel(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)` Renders the Excel view, given the specified model.
    `protected void` | `setText(org.apache.poi.hssf.usermodel.HSSFCell cell, String text)` Convenient method to set a String as text content in a cell.
    `void` | `setUrl(String url)` Set the URL of the Excel workbook source, without localization part nor extension.

    - ### Methods inherited from class org.springframework.web.servlet.view.AbstractView

      `addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposePathVariables, setRequestContextAttribute, setResponseContentType, toString, writeToResponse`

    - ### Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport

      `getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

    - ### Methods inherited from class org.springframework.context.support.ApplicationObjectSupport

      `getApplicationContext, getMessageSourceAccessor, initApplicationContext, requiredContextClass, setApplicationContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractExcelView

          public AbstractExcelView()

      Default Constructor. Sets the content type of the view to "application/vnd.ms-excel".

  - ### Method Detail

    - #### setUrl

          public void setUrl(String url)

      Set the URL of the Excel workbook source, without localization part nor extension.

    - #### generatesDownloadContent

          protected boolean generatesDownloadContent()

      Description copied from class: `AbstractView`
      Return whether this view generates download content (typically binary content like PDF or Excel files).

      The default implementation returns `false`. Subclasses are encouraged to return `true` here if they know that they are generating download content that requires temporary caching on the client side, typically via the response OutputStream.

      Overrides:
        `generatesDownloadContent` in class `AbstractView`
      See Also:
        `AbstractView.prepareResponse(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)`, `ServletResponse.getOutputStream()`

    - #### renderMergedOutputModel

          protected final void renderMergedOutputModel(Map<String,Object> model,
                                     HttpServletRequest request,
                                     HttpServletResponse response)
                                                throws Exception

      Renders the Excel view, given the specified model.
      Specified by:
        `renderMergedOutputModel` in class `AbstractView`
      Parameters:
        `model` - combined output Map (never `null`), with dynamic values taking precedence over static attributes
        `request` - current HTTP request
        `response` - current HTTP response
      Throws:
        `Exception` - if rendering failed

    - #### getTemplateSource

          protected org.apache.poi.hssf.usermodel.HSSFWorkbook getTemplateSource(String url,
                                                                     HttpServletRequest request)
                                                                          throws Exception

      Creates the workbook from an existing XLS document.
      Parameters:
        `url` - the URL of the Excel template without localization part nor extension
        `request` - current HTTP request
      Returns:
        the HSSFWorkbook
      Throws:
        `Exception` - in case of failure

    - #### buildExcelDocument

          protected abstract void buildExcelDocument(Map<String,Object> model,
                                org.apache.poi.hssf.usermodel.HSSFWorkbook workbook,
                                HttpServletRequest request,
                                HttpServletResponse response)
                                              throws Exception

      Subclasses must implement this method to create an Excel HSSFWorkbook document, given the model.
      Parameters:
        `model` - the model Map
        `workbook` - the Excel workbook to complete
        `request` - in case we need locale etc. Shouldn't look at attributes.
        `response` - in case we need to set cookies. Shouldn't write to it.
      Throws:
        `Exception`

    - #### getCell

          protected org.apache.poi.hssf.usermodel.HSSFCell getCell(org.apache.poi.hssf.usermodel.HSSFSheet sheet,
                                                       int row,
                                                       int col)

      Convenient method to obtain the cell in the given sheet, row and column.

      Creates the row and the cell if they still doesn't already exist. Thus, the column can be passed as an int, the method making the needed downcasts.

      Parameters:
        `sheet` - a sheet object. The first sheet is usually obtained by workbook.getSheetAt(0)
        `row` - thr row number
        `col` - the column number
      Returns:
        the HSSFCell

    - #### setText

          protected void setText(org.apache.poi.hssf.usermodel.HSSFCell cell,
                     String text)

      Convenient method to set a String as text content in a cell.
      Parameters:
        `cell` - the cell in which the text must be put
        `text` - the text to put in the cell